﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="LongPolling.aspx.cs" Inherits="AjaxFinder.LongPolling" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <script src="Scripts/jquery-1.4.1.js" type="text/javascript"></script>
    <title></title>
    <script type="text/javascript">
        var userID = 0;
        function SendXHR() {
            $.ajax({
                type: "post", //AJAX请求类型
                url: "LongPollingServer.ashx", //请求url
                cache: false,  //无缓存
                timeout: 1000 * 80,  //AJAX请求超时时间为60秒
                data: { time: 60, userID: userID }, //参数time时间为最多等待（后台保持）时间(60秒无论是否有数据立即返回)，单位为秒。userID判断诗句是否为新数据的标识
                success: function (data, textStatus) {
                    var obj = document.getElementById("NameDisplay");
                    //判断返回成功还是失败  如果后台保持连接的时间一到并且没有新数据就会返回fail开头失败的数据
                    if (data != null && data != "" && !(data.indexOf("fail") != -1)) {
                        var strarr = data.split(",");
                       // alert(strarr[0]);
                        userID = strarr[0];
                        obj.innerHTML = "亲！有新用户注册哦！用户名：" + strarr[1];
                    }
                    else {
                        obj.innerHTML = "亲！暂无新用户注册哦";
                    }
                    SendXHR();//请求后立即发起AJAX请求
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //New Error do something
                    if (textStatus == "timeout") {
                        //超时间
                        SendXHR();
                    }
                }

            });
        }
        window.onload = function () {
            SendXHR();
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    </div>
        <div id="NameDisplay">
        </div>
    </form>
</body>
</html>
