﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;
using System.Net;
using System.Threading;
using System.Data;

namespace AjaxFinder
{
    /// <summary>
    /// AJAX长轮询后台处理页面
    /// 主要用于保持连接
    /// 有数据返回，无数据继续保持连接超时返回
    /// author:bluescreen
    /// Date  :2013-03-14
    /// blog:http://www.cnblogs.com/bluescreen/
    /// 请不要关注代码编写规范等一些问题。这仅仅是一个DEMO
    /// 还存在诸多问题
    /// </summary>
    public class LongPollingServer : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
           /*
            context.Response.ContentType = "text/plain";
            context.Response.Write("Hello World");*/
            int SendTime = 0;  //最多等待时间
            int userID = 0;    //上一次的用户ID
            if (context.Request.Form["time"] != null&&context.Request.Form["time"].ToString()!="")
            {
                SendTime =int.Parse(context.Request.Form["time"].ToString());//接收传来的的后台要保持时间
            }
            if (context.Request.Form["userID"] != null && context.Request.Form["userID"].ToString() != "")
            {
                userID = int.Parse(context.Request.Form["userID"].ToString());
            }
            int i = 0;//计算超时时间（秒）
            while (true)
            {
                Thread.Sleep(1000);//停留一千毫秒（1秒）
                i++;
                if (i < SendTime)
                {
                    if (NameStr(userID) != "")
                    {
                        context.Response.Write(NameStr(userID));
                        break;
                    }
                }
                if (i == SendTime)
                {
                    context.Response.Write("fail:无数据");
                    break;
                }
            }
        }
        /// <summary>
        /// 获得用户名
        /// </summary>
        /// <param name="userID"></param>
        /// <returns></returns>
        private string NameStr(int userID)
        {
            string result = string.Empty;
            string Sqlstr = "select top 1 ID,UserName from AjaxPolling   Order by ID desc";
            DataSet ds = new DataSet();
            ds = SQLHelper.Query(Sqlstr, null);
            if (ds != null)
            {
                if (ds.Tables[0].Rows.Count >= 1)
                {
                    if (int.Parse(ds.Tables[0].Rows[0][0].ToString()) != userID || 0 ==int.Parse(ds.Tables[0].Rows[0][0].ToString()))
                    {
                        result = ds.Tables[0].Rows[0][0].ToString() + "," + ds.Tables[0].Rows[0][1].ToString();
                    }
                }
            }

            return result;
        }
        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}